local L = LibStub("AceLocale-3.0"):GetLocale("Broker_AddonControl")
Broker_AddonControlUI = {}

function Broker_AddonControlUI.CreateConfigMenu()
	local configPanel = CreateFrame("Frame", "Broker_SelfCastConfigFrame", UIParent)
	configPanel.name = "Broker_SelfCast"
	configPanel.okay = function (self) return end
	configPanel.cancel = function (self) return end

	local addonName, addonTitle, addonNotes = GetAddOnInfo('Broker_SelfCast')
	local configPanelText = configPanel:CreateFontString(nil, 'ARTWORK', 'GameFontNormalLarge')
	configPanelText:SetPoint('TOPLEFT', 16, -16)
	configPanelText:SetText(addonTitle)

	local configPanelDesc = configPanel:CreateFontString(nil, 'ARTWORK', 'GameFontHighlightSmall')
	--configPanelDesc:SetHeight(32)
	configPanelDesc:SetPoint('TOPLEFT', configPanelText, 'BOTTOMLEFT', 0, -8)
	configPanelDesc:SetPoint('RIGHT', configPanel, -32, 0)
	configPanelDesc:SetNonSpaceWrap(true)
	configPanelDesc:SetJustifyH('LEFT')
	configPanelDesc:SetJustifyV('TOP')
	configPanelDesc:SetText(addonNotes)
	
	local showLock = Broker_AddonControlUI.CreateCheckButton(L["Manual Mode"], configPanel ,L["Manual Mode"], "manualMode",'InterfaceOptionsCheckButtonTemplate')
	showLock:SetPoint('TOPLEFT', configPanelDesc, 'BOTTOMLEFT', 2, -10)

	local barAlphaDesc = configPanel:CreateFontString(nil, 'ARTWORK', 'GameFontNormal')
	barAlphaDesc:SetPoint('TOPLEFT', showLock, 'BOTTOMLEFT', -10, -10)
	barAlphaDesc:SetText(L["Update Frequency"])

	local BarUpdateFreq = CreateFrame("Slider", configPanel:GetName() .. "UpdateFreq", configPanel, "OptionsSliderTemplate")
	BarUpdateFreq:SetMinMaxValues(0.1, 30.0)
	BarUpdateFreq:SetValueStep(0.1)
	BarUpdateFreq:SetValue(Broker_SelfCast.GetConfigValue("updateInterval"))
	_G[BarUpdateFreq:GetName() .. "High"]:SetText("30.0")
	_G[BarUpdateFreq:GetName() .. "Low"]:SetText("0.1")
	BarUpdateFreq:SetScript("OnValueChanged", Broker_AddonControlUI.BarUpdateFreqChanged)
	BarUpdateFreq:SetPoint('TOPLEFT', barAlphaDesc, 'BOTTOMLEFT', 10, 0)
	
	Broker_SelfCast.updateFreqValue = configPanel:CreateFontString(nil, 'ARTWORK', 'GameFontNormal')
	Broker_SelfCast.updateFreqValue:SetPoint('TOPLEFT', BarUpdateFreq, 'TOPRIGHT', 10, 2)
	Broker_SelfCast.updateFreqValue:SetText(string.format("%.1f", Broker_SelfCast.GetConfigValue("updateInterval")))	

	local soloStatusDesc = configPanel:CreateFontString(nil, 'ARTWORK', 'GameFontNormal')
	soloStatusDesc:SetPoint('TOPLEFT', BarUpdateFreq, 'BOTTOMLEFT', -10, -15)
	soloStatusDesc:SetText(L["Not Grouped"])	
	soloStatusDesc:SetJustifyH("LEFT")
	soloStatusDesc:SetHeight(18)
	soloStatusDesc:SetWidth(100)
	local dropdown = CreateFrame("Frame", "soloStatusSelfCastDropDown", configPanel, "UIDropDownMenuTemplate")
	dropdown:SetPoint("TOPLEFT", soloStatusDesc, "TOPRIGHT", 16, 3)
	local function itemOnClick(self)
		local selected = self.value
		Broker_SelfCast.SetConfigValue("soloStatus",selected)
		UIDropDownMenu_SetSelectedValue(dropdown, selected)
	end
	UIDropDownMenu_Initialize(dropdown, function()
		local info = UIDropDownMenu_CreateInfo()
		info.text = L["On"]
		info.value = L["On"]
		info.func = itemOnClick
		info.checked = L["On"] == Broker_SelfCast.GetConfigValue("soloStatus")
		UIDropDownMenu_AddButton(info)
		info.text = L["Off"]
		info.value = L["Off"]
		info.func = itemOnClick
		info.checked = L["Off"] == Broker_SelfCast.GetConfigValue("soloStatus")
		UIDropDownMenu_AddButton(info)
		info.text = L["Deactived"]
		info.value = L["Deactived"]
		info.func = itemOnClick
		info.checked = L["Deactived"] == Broker_SelfCast.GetConfigValue("soloStatus")
		UIDropDownMenu_AddButton(info)		
	end)
	
	UIDropDownMenu_SetSelectedValue(dropdown, Broker_SelfCast.GetConfigValue("soloStatus"))
	UIDropDownMenu_SetWidth(dropdown, 160)
	UIDropDownMenu_JustifyText(dropdown, "LEFT")	
	
	local groupStatusDesc = configPanel:CreateFontString(nil, 'ARTWORK', 'GameFontNormal')
	groupStatusDesc:SetPoint('TOPLEFT', soloStatusDesc, 'BOTTOMLEFT', 0, -15)
	groupStatusDesc:SetText(L["In Group"])	
	groupStatusDesc:SetJustifyH("LEFT")
	groupStatusDesc:SetHeight(18)
	groupStatusDesc:SetWidth(100)
	local dropdown = CreateFrame("Frame", "groupStatusSelfCastDropDown", configPanel, "UIDropDownMenuTemplate")
	dropdown:SetPoint("TOPLEFT", groupStatusDesc, "TOPRIGHT", 16, 3)
	local function itemOnClickG(self)
		local selected = self.value
		Broker_SelfCast.SetConfigValue("groupedStatus",selected)
		UIDropDownMenu_SetSelectedValue(dropdown, selected)
	end
	UIDropDownMenu_Initialize(dropdown, function()
		local info = UIDropDownMenu_CreateInfo()
		info.text = L["On"]
		info.value = L["On"]
		info.func = itemOnClickG
		info.checked = L["On"] == Broker_SelfCast.GetConfigValue("groupedStatus")
		UIDropDownMenu_AddButton(info)
		info.text = L["Off"]
		info.value = L["Off"]
		info.func = itemOnClickG
		info.checked = L["Off"] == Broker_SelfCast.GetConfigValue("groupedStatus")
		UIDropDownMenu_AddButton(info)
		info.text = L["Deactived"]
		info.value = L["Deactived"]
		info.func = itemOnClickG
		info.checked = L["Deactived"] == Broker_SelfCast.GetConfigValue("groupedStatus")
		UIDropDownMenu_AddButton(info)		
	end)
	
	UIDropDownMenu_SetSelectedValue(dropdown, Broker_SelfCast.GetConfigValue("groupedStatus"))
	UIDropDownMenu_SetWidth(dropdown, 160)
	UIDropDownMenu_JustifyText(dropdown, "LEFT")		
	
	local raidStatusDesc = configPanel:CreateFontString(nil, 'ARTWORK', 'GameFontNormal')
	raidStatusDesc:SetPoint('TOPLEFT', groupStatusDesc, 'BOTTOMLEFT', 0, -15)
	raidStatusDesc:SetText(L["In Raid"])	
	raidStatusDesc:SetJustifyH("LEFT")
	raidStatusDesc:SetHeight(18)
	raidStatusDesc:SetWidth(100)
	local dropdown = CreateFrame("Frame", "raidStatusSelfCastDropDown", configPanel, "UIDropDownMenuTemplate")
	dropdown:SetPoint("TOPLEFT", raidStatusDesc, "TOPRIGHT", 16, 3)
	local function itemOnClickR(self)
		local selected = self.value
		Broker_SelfCast.SetConfigValue("raidStatus",selected)
		UIDropDownMenu_SetSelectedValue(dropdown, selected)
	end
	UIDropDownMenu_Initialize(dropdown, function()
		local info = UIDropDownMenu_CreateInfo()
		info.text = L["On"]
		info.value = L["On"]
		info.func = itemOnClickR
		info.checked = L["On"] == Broker_SelfCast.GetConfigValue("raidStatus")
		UIDropDownMenu_AddButton(info)
		info.text = L["Off"]
		info.value = L["Off"]
		info.func = itemOnClickR
		info.checked = L["Off"] == Broker_SelfCast.GetConfigValue("raidStatus")
		UIDropDownMenu_AddButton(info)
		info.text = L["Deactived"]
		info.value = L["Deactived"]
		info.func = itemOnClickR
		info.checked = L["Deactived"] == Broker_SelfCast.GetConfigValue("raidStatus")
		UIDropDownMenu_AddButton(info)		
	end)
	
	UIDropDownMenu_SetSelectedValue(dropdown, Broker_SelfCast.GetConfigValue("raidStatus"))
	UIDropDownMenu_SetWidth(dropdown, 160)
	UIDropDownMenu_JustifyText(dropdown, "LEFT")			
	
	InterfaceOptions_AddCategory(configPanel)
end

function Broker_AddonControlUI.BarUpdateFreqChanged(self, value)
	Broker_SelfCast.UPDATE_INTERVAL = value
	Broker_SelfCast.SetConfigValue("updateInterval", value)
	Broker_SelfCast.updateFreqValue:SetText(string.format("%.1f", Broker_SelfCast.GetConfigValue("updateInterval")))		
end

function Broker_AddonControlUI.CreateCheckButton(name, parent, tooltipText, configKey, template)
	local button = CreateFrame('CheckButton', parent:GetName() .. name, parent, template)
	_G[button:GetName() .. 'Text']:SetText(name)
	button:SetChecked(Broker_SelfCast.GetConfigValue(configKey))
	button:SetScript('OnClick', function(self)
		if self:GetChecked() then
			Broker_SelfCast.SetConfigValue(configKey, true)
		else 
			Broker_SelfCast.SetConfigValue(configKey, false)
		end
		if ( self.dependentControls ) then
			if ( self:GetChecked() ) then
				for _, control in pairs(self.dependentControls) do
					control:Enable()
				end
			else
				for _, control in pairs(self.dependentControls) do
					control:Disable()
				end
			end
		end
		if ( self.inverseDependentControls ) then
			if ( self:GetChecked() ) then
				for _, control in pairs(self.inverseDependentControls) do
					control:Disable()
				end
			else
				for _, control in pairs(self.inverseDependentControls) do
					control:Enable()
				end
			end
		end
		Broker_SelfCast.Update();
	end)
	button:SetScript('OnEnter', function(self)
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
		GameTooltip:SetText(tooltipText, nil, nil, nil, 1, 1)
		GameTooltip:Show() end)
	button:SetScript('OnLeave', function(self) GameTooltip:Hide() end)

	return button
end

function Broker_AddonControlUI.SetupDependentControl (dependency, control)
	if ( not dependency ) then
		return
	end
	
	assert(control)
	
	dependency.dependentControls = dependency.dependentControls or {}
	tinsert(dependency.dependentControls, control)

	if ( control.type ~= CONTROLTYPE_DROPDOWN ) then
		control.Disable = function (self) getmetatable(self).__index.Disable(self) _G[self:GetName().."Text"]:SetTextColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b) end
		control.Enable = function (self) getmetatable(self).__index.Enable(self) _G[self:GetName().."Text"]:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b) end
		if dependency:GetChecked() then
			control:Enable()
		else
			control:Disable()
		end
	else
		control.Disable = function (self) UIDropDownMenu_DisableDropDown(self) end
		control.Enable = function (self) UIDropDownMenu_EnableDropDown(self) end
	end

end

function Broker_AddonControlUI.SetupInverseDependentControl (dependency, control)
	if ( not dependency ) then
		return
	end
	
	assert(control)
	
	dependency.inverseDependentControls = dependency.inverseDependentControls or {}
	tinsert(dependency.inverseDependentControls, control)

	if ( control.type ~= CONTROLTYPE_DROPDOWN ) then
		control.Disable = function (self) getmetatable(self).__index.Disable(self) _G[self:GetName().."Text"]:SetTextColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b) end
		control.Enable = function (self) getmetatable(self).__index.Enable(self) _G[self:GetName().."Text"]:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b) end
		if dependency:GetChecked() then
			control:Disable()
		else
			control:Enable()
		end
	else
		control.Disable = function (self) UIDropDownMenu_DisableDropDown(self) end
		control.Enable = function (self) UIDropDownMenu_EnableDropDown(self) end
	end

end